#ifndef _FUNC_H_
#define _FUNC_H_

#define MethodName(name,type) _f_ ## name ## _AT_ ## type

#define Func(name,numparams,locals) returntype _f_ ## name (calldata * cdata) { locals;
#define EndFunc	return NORMAL_RETURN; }
#define Method(name,type,numparams,locals) returntype MethodName(name,type) (calldata * cdata) { locals;
#define Param(num,var,type) var = (_t_##type *)(
#define Ret(num,val) cdata->params[num] = (object *)(val);
#define Return return NORMAL_RETURN;
#define Exception
#define FuncDef(name) returntype _f_ ## name (calldata * cdata);
#define MethodDef(name,type) returntype MethodName(name,type) (calldata * cdata);


#endif //_FUNC_H_